F - Prime Path題後反思
F - Prime Path
本題的題意就是給定兩個數m和n,每次改變一個數的個位值或十位值或百位值或千位值,使他變成一個素數,在對該素數進行前面的操作,問至少經過幾次從m變到n |
本題考查對bfs的理解和應用,但又和一般的最短路問題有點區別,一般的最短路問題只要到了終點就可以結束,而本題到了終點不一定是最短的,而要依次比較完每一種可能,更新每一次的路徑 |
坑點:1不要有結束條件; |
坑點:2對於同一個數字入隊了就不要重複入隊,可以用一個數組來標記,入隊就標記為1,出隊就標記0; |
坑點:3用一個數組來記錄最短路,先把所有值初始化為-1,如果當前數字的路徑為-1或大於所求數字的路徑則更新路徑值 |
具體看程式碼註釋 |
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros). |
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible. |
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
程式碼實現
#include <stdio.h>
#include <math.h>
#include <queue>
#include <string.h>
using namespace std;
const int MAX=10050;
int su[MAX],book[MAX],num[4],m,n,temp,vis[MAX]; //book記錄數字是否已經入隊 //nun陣列記錄各個位的值 例如1234 記錄1 2 3 3
//
struct node{ //定義結構體儲存當前的數字和路徑
int x,step;
}en,st;
queue<node>q;
int su_t( int n){ //判斷素數 若為素數的話返回1 否則返回0
int i,t;
t=sqrt(n+0.0); //開根號,(n+0.0)轉換為double型別
for (i=2;i<=t;i++){
if (n%i==0) return 0;
}
return 1;
}
int main() {
for(int i=2;i<MAX;i++) su[i]=su_t(i); //在組數中標記下標是否為素數,素數存1 非素數存0
int t;
scanf("%d",&t);
while(t--){
memset(book,0, sizeof(book)); //初始化是否已經入隊
scanf("%d %d",&m,&n);
if(m==n) {
printf("0\n"); //特判,如果兩數相等,則返回0
continue;
}
memset(vis,-1, sizeof(vis)); //初始化路徑記錄值
flag=0;
while(!q.empty()) q.pop(); //佇列清空
st.x=m;
st.step=0;
book[st.x]=1;
vis[st.x]=0;
q.push(st); //頭入佇列
while(!q.empty()){
st=q.front();
q.pop();
book[st.x]=0; //標記隊頭已經入隊
temp=st.x;
for(int i=0;i<4;i++){ //記錄該數各個位上的值
num[i]=temp%10;
temp/=10;
}
en.step=st.step+1;
for(int i=0;i<=9;i++){ //換掉個位上的數
en.x=i+num[1]*10+num[2]*100+num[3]*1000;
if(vis[en.x]==-1 || vis[en.x]>en.step){ //如果該處vis值為-1或該處儲存的路徑值較大,則更新它
vis[en.x]=en.step;
if(su[en.x]==1&& !book[en.x]){ //如果滿足條件則入隊
book[en.x]=1; //把入隊的數標記為1
q.push(en); //入隊
}
}
}
for(int i=0;i<=9;i++){ //更換十位值 ,詳解參考上面註釋
en.x=num[0]+i*10+num[2]*100+num[3]*1000;
if(vis[en.x]==-1 || vis[en.x]>en.step){
vis[en.x]=en.step;
if(su[en.x]==1 && !book[en.x]){
book[en.x]=1;
q.push(en);
}
}
}
for(int i=0;i<=9;i++){ //更換百位值,詳解參考上面註釋
en.x=num[0]+num[1]*10+i*100+num[3]*1000;
if(vis[en.x]==-1 || vis[en.x]>en.step){
vis[en.x]=en.step;
if(su[en.x]==1 && !book[en.x]){
book[en.x]=1;
q.push(en);
}
}
}
for(int i=1;i<=9;i++){ //更換千位值,詳解參考上面註釋
en.x=num[0]+num[1]*10+num[2]*100+i*1000;
if(vis[en.x]==-1 || vis[en.x]>en.step){
vis[en.x]=en.step;
if(su[en.x]==1 && !book[en.x]) {
book[en.x]=1;
q.push(en);
}
}
}
}
printf("%d\n",vis[n]);
}
return 0;
}